// Persistence of Vision Raytracer
// This data declares Hardwood, a Floor & walls w/base moulding

//Light tan to d.brown

#declare br01 = colour red 0.93 green 0.93 blue 0.93
#declare br02 = colour red 0.89 green 0.88 blue 0.87
#declare br03 = colour red 0.82 green 0.80 blue 0.79
#declare br03 = colour red 0.82 green 0.80 blue 0.82
#declare br04 = colour red 0.70 green 0.69 blue 0.69
#declare br05 = colour red 0.61 green 0.62 blue 0.61
#declare br06 = colour red 0.63 green 0.62 blue 0.61
#declare br07 = colour red 0.61 green 0.59 blue 0.60
#declare br08 = colour red 0.54 green 0.51 blue 0.55
#declare br09 = colour red 0.51 green 0.50 blue 0.52
#declare br10 = colour red 0.46 green 0.45 blue 0.47
#declare br11 = colour red 0.47 green 0.45 blue 0.47
#declare br12 = colour red 0.47 green 0.41 blue 0.44
#declare br13 = colour red 0.43 green 0.41 blue 0.43
#declare br14 = colour red 0.40 green 0.37 blue 0.39
#declare br15 = colour red 0.42 green 0.37 blue 0.39
#declare br16 = colour red 0.38 green 0.35 blue 0.37
#declare br17 = colour red 0.36 green 0.31 blue 0.34
#declare br18 = colour red 0.35 green 0.31 blue 0.46
#declare br19 = colour red 0.35 green 0.31 blue 0.36
#declare br20 = colour red 0.31 green 0.27 blue 0.32
#declare br21 = colour red 0.30 green 0.24 blue 0.29
#declare br22 = colour red 0.27 green 0.24 blue 0.26
#declare br23 = colour red 0.27 green 0.24 blue 0.29
#declare br24 = colour red 0.24 green 0.21 blue 0.25
#declare br25 = colour red 0.29 green 0.21 blue 0.27
#declare br26 = colour red 0.22 green 0.19 blue 0.22
#declare br27 = colour red 0.20 green 0.14 blue 0.19
#declare br28 = colour red 0.20 green 0.14 blue 0.20
#declare br29 = colour red 0.14 green 0.16 blue 0.18
#declare br30 = colour red 0.15 green 0.11 blue 0.16
#declare br31 = colour red 0.06 green 0.05 blue 0.5


 #declare pop_wood = texture {
 marble
	color_map {
	[0.0 0.2 color br16 color br16] 
	[0.2 0.4 color br16 color br14]
	[0.4 0.6 color br14 color br17]
	[0.6 0.8 color br17 color br17]
	[0.8 0.9 color br17 color br14]
	[0.9 1.01 color br14 color br16]
	 }

	turbulence 0.4
	scale <13 13 1> 
	ambient 0.8 phong 0.5 
	 }

 texture {
	wood
	color_map {
	[0.0 0.05 color br25 color br25 alpha 0.5]
	[0.05 0.2 color br25 alpha 0.5 color br21 alpha 1.0]
	[0.2 0.7 color br21 alpha 1.0 color br21 alpha 0.8]
	[0.7 0.8 color br27 alpha 0.7 color br27 alpha 1.0]
	[0.8 0.9 color br27 alpha 1.0 color br27 alpha 0.7]
	[0.9 1.01 color br27 alpha 1.0 color br30 alpha 0.5]
	 }
	turbulence 0.5
	ambient 0.9
	phong 1.0
	scale <5 15 1>
	 }

/*************************************************************/

#declare zeb_wood = texture {
 marble
	color_map {
	[0.0 0.2 color br16 color br16] 
	[0.2 0.4 color br16 color br14]
	[0.4 0.6 color br14 color br17]
	[0.6 0.8 color br17 color br17]
	[0.8 0.9 color br17 color br14]
	[0.9 1.01 color br14 color br16]
	 }
	ambient 0.3
	diffuse 1.2
	turbulence 0.25
	scale <13 13 1>
	 }

 texture {
	wood
	color_map {
	[0.0 0.05 color br25 color br25 alpha 0.7]
	[0.05 0.2 color br25 alpha 0.7 color br21 alpha 1.0]
	[0.2 0.7 color br21 alpha 1.0 color br21 alpha 0.8]
	[0.7 0.8 color br27 alpha 0.7 color br27 alpha 1.0]
	[0.8 0.9 color br27 alpha 1.0 color br27 alpha 0.7]
	[0.9 1.01 color br27 alpha 1.0 color br30 alpha 0.7]
	 }
	turbulence 0.3
	ambient 0.6
	diffuse 0.9
	scale <5 15 5>
	 }

texture {
	wood
	color_map {
	[0.0 0.05 color br25 color br25 alpha 0.4]
	[0.05 0.2 color br25 alpha 0.4 color br21 alpha 0.8]
	[0.2 0.7 color br21 alpha 0.8 color br21 alpha 0.9]
	[0.7 0.8 color br27 alpha 0.8 color br27 alpha 0.6]
	[0.8 0.9 color br27 alpha 0.6 color br27 alpha 0.4]
	[0.9 1.01 color br27 alpha 0.5 color br30 alpha 0.8]
	 }
	diffuse 0.9
	ambient 0.3
	turbulence 0.2
	scale <4 20 4>
	 }

#declare wthr_wood = texture {
 marble
	color_map {
	[0.0 0.2 color br16 color br16] 
	[0.2 0.4 color br16 color br14]
	[0.4 0.6 color br14 color br17]
	[0.6 0.8 color br17 color br17]
	[0.8 0.9 color br17 color br14]
	[0.9 1.01 color br14 color br16]
	 }
	//ambient 0.2
	diffuse 0.3
	turbulence 0.25
	scale <13 13 1>
	 }

 texture {
	wood
	color_map {
	[0.0 0.05 color br25 color br25 alpha 0.7]
	[0.05 0.2 color br25 alpha 0.7 color br21 alpha 1.0]
	[0.2 0.7 color br21 alpha 1.0 color br21 alpha 0.8]
	[0.7 0.8 color br27 alpha 0.7 color br27 alpha 1.0]
	[0.8 0.9 color br27 alpha 1.0 color br27 alpha 0.7]
	[0.9 1.01 color br27 alpha 1.0 color br30 alpha 0.7]
	 }
	turbulence 0.3
	//ambient 0.3
	diffuse 0.3
	scale <5 15 5>
	 }

texture {
	wood
	color_map {
	[0.0 0.05 color br25 color br25 alpha 0.4]
	[0.05 0.2 color br25 alpha 0.4 color br21 alpha 0.8]
	[0.2 0.7 color br21 alpha 0.8 color br21 alpha 0.9]
	[0.7 0.8 color br27 alpha 0.8 color br27 alpha 0.6]
	[0.8 0.9 color br27 alpha 0.6 color br27 alpha 0.4]
	[0.9 1.01 color br27 alpha 0.5 color br30 alpha 0.8]
	 }
	diffuse 0.2
	//ambient 0.15
	turbulence 0.2
	scale <4 20 4>
	 }


/*------------------ MAKE HARDWOOD FLOOR ----------------------------------*/

#declare wt = texture {
zeb_wood 0.01 scale <15 35 20> phong 0.5 phong_size 20 
reflection 0.3  }

#declare wthr = texture {
wthr_wood 0.01 scale <15 35 20> //phong 0.1 phong_size 20 
//reflection 0.001  
}

/* normal oak plank 
#declare plank = object {
intersection { Cube scale <100 3000 0.5>  }
texture { wt  }
 }
 */
/* weathered plank */
#declare plank = object {
intersection { Cube scale <100 3000 0.5>  }
texture { wthr  }
 }

#declare the_floor = composite {
object { plank texture { wt translate <-5 17 0>  } translate <0 0 0>  }
object { plank texture { wt translate <0 60 0>  } translate <204 0 0>  }
object { plank texture { wt translate <10 50 0> rotate <0 0 -10>  } translate <408 0 0>  }
object { plank texture { wt translate <0 -70 0>  } translate <612 0 0>  }
object { plank texture { wt translate <2 -30 0>  } translate <-204 0 0>  }
object { plank texture { wt translate <0 -17 0>  } translate <-408 0 0>  }
object { plank texture { wt translate <5 -50 0> rotate <0 0 10>  } translate <-612 0 0>  }
object { plank texture { wt translate <7 -50 0> rotate <0 0 0>  } translate <816 0 0>  }

object { plank texture { wt translate <0 -50 0> rotate <0 0 10>  } translate <1020 0 0>  }
object { plank texture { wt translate <0 -100 0> rotate <0 0 0>  } translate <1224 0 0>  }
object { plank texture { wt translate <0 -70 0> rotate <0 0 0>  } translate <1428 0 0>  }
object { plank texture { wt translate <0 50 0> rotate <0 0 0>  } translate <1632 0 0>  }
object { plank texture { wt translate <0 -50 0> rotate <0 0 0>  } translate <1836 0 0>  }
object { plank texture { wt translate <0 -100 0> rotate <0 0 0>  } translate <2040 0 0>  }
object { plank texture { wt translate <0 -70 0> rotate <0 0 0>  } translate <2244 0 0>  }
object { plank texture { wt translate <0 50 0> rotate <0 0 0>  } translate <2448 0 0>  }


object { intersection { Cube scale <1800 3000 1.2>  }
texture { color Black  } translate <0 -1 20>  }
bounded_by {
intersection { Cube scale <2720 3000 5>  }
 }
 }


/*

/*--------------------START THE WALLS-------------------------*/

#declare cwall = texture {
color DarkSlateGray  diffuse 0.7  }

/*----------------  Build BaseBoards  ------------------------*/




#declare baseboard = object {
difference {
union {
intersection { Cube scale <300 50 120> translate <0 50 0>  }
intersection { Cube scale <290 25 110> translate <0 125 0>  }
quadric { Ellipsoid scale <10 10 10> translate <290 110 -110>  }
quadric { Ellipsoid scale <10 10 10> translate <290 110 110>  }
intersection { Disk_X scale <580 10 10> translate <-290 110 -110>  }
intersection { Disk_Z scale <10 10 220> translate <290 110 -110>  }

//Quarter Round
quadric { Ellipsoid scale <20 20 20> translate <300 -10 -120>  }
quadric { Ellipsoid scale <20 20 20> translate <300 -10 120>  }
quadric { Ellipsoid scale <20 20 20> translate <-300 -10 -120>  }
intersection { Disk_X scale <600 20 20> translate <-300 -10 -120>  }
intersection { Disk_Z scale <20 20 240> translate <300 -10 -120>  }
intersection { Disk_Z scale <20 20 240> translate <-300 -10 -120>  }


 }
quadric { Cylinder_X scale <1 20 20> translate <0 150 -110>  }
quadric { Cylinder_Z scale <20 20 1> translate <290 150 0>  }
quadric { Cylinder_Z scale <20 20 1> translate <-290 150 0>  }
 }
texture { 
color Gray ambient 0.2 diffuse 0.7 phong 1.0  
 }
bounded_by { 
intersection { Cube scale <325 80 155> translate <0 77 0>  }
 }
 }

/*--------------- THE PLASTER WALL ------------------------------------*/
#declare plaster = object {
intersection { Cube scale <260 750 80>  }
texture { cwall  }
 }

/*-------------- WALL WITH BASE ATTACHED ------------------------------*/
#declare wall = composite {
object { plaster translate <0 900 0>  }
object { baseboard  }
 }

*/



